SystemOrganization addCategory: #EpigentRiakInterfaceCore!

Object subclass: #EpigentRiakConnection
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

EpigentRiakConnection subclass: #EpigentRiakRestConnection
	instanceVariableNames: 'location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

!EpigentRiakRestConnection class methodsFor: 'instance creation' stamp: 'RunarJordahl 2/13/2011 16:30'!
newWithLocation: aHttpUrl

	^self new location: aHttpUrl;yourself! !

!EpigentRiakRestConnection methodsFor: 'action' stamp: 'RunarJordahl 2/16/2011 11:28'!
bucket: bucketName key: keyName put: object type: typeString headers: aHeaderInfo queryParameters: aQueryParametersInfo
	| url response |
	url := self location newFromRelativeText: '/riak/' , bucketName , '/' , keyName.
	response := ZnClient
		put: url
		data: (ZnEntity with: object type: typeString)
		headers:
			((Dictionary new)
				at: 'X-Riak-Meta-Test' put: 't';
				yourself).
	^ response! !

!EpigentRiakRestConnection methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 21:38'!
bucketsArray
	| url response |
	url := self location newFromRelativeText: '/riak?buckets=true'.
	response := ZnClient get: url.
	^ (Json readFrom: response contents readStream) at: 'buckets'! !

!EpigentRiakRestConnection methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 18:17'!
location
	^ location! !

!EpigentRiakRestConnection methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 18:16'!
location: a

	location := a! !

!EpigentRiakRestConnection methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 21:49'!
objectIn: bucketName for: key
	| url response |
	url := self location newFromRelativeText: '/riak/', bucketName, 'key'.
	response := ZnClient get: url.
	^ (Json readFrom: response contents readStream) at: 'buckets'! !

Object subclass: #EpigentRiakSession
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EpigentRiakInterfaceCore'!

EpigentRiakSession class
	instanceVariableNames: 'location'!

EpigentRiakSession class
	instanceVariableNames: 'location'!

!EpigentRiakSession class methodsFor: 'instance creation' stamp: 'RunarJordahl 2/13/2011 18:20'!
newForLocation: urlString

	^self new connection:	(EpigentRiakRestConnection newWithLocation: (Url absoluteFromText: urlString))yourself! !

!EpigentRiakSession methodsFor: 'action' stamp: 'RunarJordahl 2/16/2011 11:28'!
bucket: bucketName key: keyName put: object type: typeString headers: aHeaderInfo queryParameters: aQueryParametersInfo
	^ self connection
		bucket: bucketName
		key: keyName
		put: object
		type: typeString
		headers: aHeaderInfo
		queryParameters: aQueryParametersInfo! !

!EpigentRiakSession methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 20:24'!
bucketNames

	^self connection bucketsArray! !

!EpigentRiakSession methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 16:21'!
connection

	^ connection! !

!EpigentRiakSession methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 16:21'!
connection: anObject

	connection := anObject! !

!EpigentRiakSession methodsFor: 'accessing' stamp: 'RunarJordahl 2/13/2011 21:37'!
objectIn: bucketName for: key
	^ self connection objectIn: bucketName for: key! !
